
var header_spy_options = {
    options : null,
    tree    : null,
    tree_children : null,

    add2list: function(tc, p) {
        var tri = document.createElement("treeitem");
        var trr = document.createElement("treerow");
        var trc1 = document.createElement("treecell");
        var trc2 = document.createElement("treecell");
        var trc3 = document.createElement("treecell");
        var trc4 = document.createElement("treecell");

        trc1.setAttribute("label", (0 == p.headersrc ? "Request" : "Response"));
        trc2.setAttribute("label", p.header);
        trc3.setAttribute("label", p.popup_headers.request);
        trc4.setAttribute("label", p.popup_headers.response);

        trr.appendChild(trc1);
        trr.appendChild(trc2);
        trr.appendChild(trc3);
        trr.appendChild(trc4);
        tri.appendChild(trr);

        tc.appendChild(tri);
    },

    update: function() {
        var b = (header_spy_options_store.defaults.max_panels > this.options.panels.length);
        document.getElementById("header-spy-panels-add").disabled = !b;

        b = (this.tree.view.selection.currentIndex >= 0);
        document.getElementById("header-spy-panels-modify").disabled = !b;

        document.getElementById("header-spy-panels-delete").disabled = (!b || this.options.panels.length < 2);
    },

    rebuild: function() {
        var tc = this.tree_children;
        var p = this.options.panels;

        for (i = tc.childNodes.length - 1 ; i >= 0 ; i--) tc.removeChild(tc.childNodes[i]); // clear list
        for (i = 0 ; i < p.length ; i++) this.add2list(tc, p[i]); // fill list

        this.update();
    },

    load: function() {
        this.options        = header_spy_options_store.get();
        this.tree           = document.getElementById("header-spy-panels-list");
        this.tree_children  = document.getElementById("header-spy-panels-list-children");
        
        this.rebuild();
    },


    save: function() {
        header_spy_options_store.save(this.options);
    },

    panels_list_selected: function() {
        this.update();
    },

    panel_new: function() {
        var p = header_spy_options_store.get_rec(this.options.panels.length);
        var opt = { saved : false };
        
        window.openDialog("chrome://header_spy/content/options-panel.xul"
            , "dlg"/*"_blank"*/, "chrome,resizable=no,modal"
            , p, opt);

        var i = this.tree.view.selection.currentIndex;
        if (opt.saved) {
            this.options.panels.push(p);
            i = this.options.panels.length - 1; // index

            this.rebuild();
        }

        this.tree.focus();
        this.tree.view.selection.select(i);
    },

    panel_modify: function() {
        var i = this.tree.view.selection.currentIndex;
        if (i < 0) return;

        var p = this.options.panels[i];
        var opt = { saved : false };
        
        window.openDialog("chrome://header_spy/content/options-panel.xul"
            , "dlg"/*"_blank"*/, "chrome,resizable=no,modal"
            , p, opt);
        
        if (opt.saved) {
            this.options.panels[i] = p;
            this.rebuild();
        }
        
        this.tree.focus();
        this.tree.view.selection.select(i);
    },

    panel_delete: function() {
        var i = this.tree.view.selection.currentIndex;
        if (i < 0) return;

        this.options.panels.splice(i, 1); // remove(i)
        this.tree_children.removeChild(this.tree_children.childNodes[i]);
        
        this.rebuild();

        this.tree.focus();
    }
};
//window.addEventListener("load", function() {header_spy_options.load();}, false);
